diff -Naurd cluster-3.0.0.rc2/gfs2/fsck/pass4.c cluster-3.0.0.rc3/gfs2/fsck/pass4.c
--- cluster-3.0.0.rc2/gfs2/fsck/pass4.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/fsck/pass4.c	2009-06-11 11:02:55.000000000 +0200
@@ -1,6 +1,8 @@
 #include <inttypes.h>
 #include <stdlib.h>
 #include <stdio.h>
+#include <libintl.h>
+#define _(String) gettext(String)
 
 #include "libgfs2.h"
 #include "fsck.h"
@@ -9,24 +11,24 @@
 
 /* Updates the link count of an inode to what the fsck has seen for
  * link count */
-int fix_inode_count(struct gfs2_sbd *sbp, struct inode_info *ii,
+static int fix_inode_count(struct gfs2_sbd *sbp, struct inode_info *ii,
 					struct gfs2_inode *ip)
 {
-	log_info("Fixing inode count for %llu (0x%llx) \n",
+	log_info( _("Fixing inode count for %llu (0x%llx) \n"),
 		 (unsigned long long)ip->i_di.di_num.no_addr,
 		 (unsigned long long)ip->i_di.di_num.no_addr);
 	if(ip->i_di.di_nlink == ii->counted_links)
 		return 0;
 	ip->i_di.di_nlink = ii->counted_links;
 
-	log_debug("Changing inode %llu (0x%llx) to have %u links\n",
+	log_debug( _("Changing inode %llu (0x%llx) to have %u links\n"),
 		  (unsigned long long)ip->i_di.di_num.no_addr,
 		  (unsigned long long)ip->i_di.di_num.no_addr,
 		  ii->counted_links);
 	return 0;
 }
 
-int scan_inode_list(struct gfs2_sbd *sbp, osi_list_t *list) {
+static int scan_inode_list(struct gfs2_sbd *sbp, osi_list_t *list) {
 	osi_list_t *tmp;
 	struct inode_info *ii;
 	struct gfs2_inode *ip;
@@ -41,32 +43,32 @@
 			return 0;
 		f = not_updated;
 		if(!(ii = osi_list_entry(tmp, struct inode_info, list))) {
-			log_crit("osi_list_foreach broken in scan_info_list!!\n");
+			log_crit( _("osi_list_foreach broken in scan_info_list!!\n"));
 			exit(FSCK_ERROR);
 		}
-		log_debug("Checking reference count on inode at block %" PRIu64
-				  " (0x%" PRIx64 ")\n", ii->inode, ii->inode);
+		log_debug( _("Checking reference count on inode at block %" PRIu64
+				  " (0x%" PRIx64 ")\n"), ii->inode, ii->inode);
 		if(ii->counted_links == 0) {
-			log_err("Found unlinked inode at %" PRIu64 " (0x%" PRIx64 ")\n",
+			log_err( _("Found unlinked inode at %" PRIu64 " (0x%" PRIx64 ")\n"),
 					ii->inode, ii->inode);
 			if(gfs2_block_check(sbp, bl, ii->inode, &q)) {
 				stack;
 				return -1;
 			}
 			if(q.bad_block) {
-				log_err("Unlinked inode %llu (0x%llx) contains"
-					"bad blocks\n",
+				log_err( _("Unlinked inode %llu (0x%llx) contains"
+					"bad blocks\n"),
 					(unsigned long long)ii->inode,
 					(unsigned long long)ii->inode);
 				errors_found++;
 				if(query(&opts,
-						 "Clear unlinked inode with bad blocks? (y/n) ")) {
+						 _("Clear unlinked inode with bad blocks? (y/n) "))) {
 					errors_corrected++;
 					gfs2_block_set(sbp, bl, ii->inode,
 						       gfs2_block_free);
 					continue;
 				} else
-					log_err("Unlinked inode with bad blocks not cleared\n");
+					log_err( _("Unlinked inode with bad blocks not cleared\n"));
 			}
 			if(q.block_type != gfs2_inode_dir &&
 			   q.block_type != gfs2_inode_file &&
@@ -75,10 +77,10 @@
 			   q.block_type != gfs2_inode_chr &&
 			   q.block_type != gfs2_inode_fifo &&
 			   q.block_type != gfs2_inode_sock) {
-				log_err("Unlinked block marked as inode not an inode\n");
+				log_err( _("Unlinked block marked as inode not an inode\n"));
 				gfs2_block_set(sbp, bl, ii->inode,
 					       gfs2_block_free);
-				log_err("Cleared\n");
+				log_err( _("Cleared\n"));
 				continue;
 			}
 			ip = fsck_load_inode(sbp, ii->inode);
@@ -87,9 +89,9 @@
 			 * eattrs - there might be relevent info in
 			 * them. */
 			if(!ip->i_di.di_size && !ip->i_di.di_eattr){
-				log_err("Unlinked inode has zero size\n");
+				log_err( _("Unlinked inode has zero size\n"));
 				errors_found++;
-				if(query(&opts, "Clear zero-size unlinked inode? (y/n) ")) {
+				if(query(&opts, _("Clear zero-size unlinked inode? (y/n) "))) {
 					errors_corrected++;
 					gfs2_block_set(sbp, bl, ii->inode,
 						       gfs2_block_free);
@@ -99,7 +101,7 @@
 
 			}
 			errors_found++;
-			if(query(&opts, "Add unlinked inode to lost+found? (y/n)")) {
+			if(query(&opts, _("Add unlinked inode to lost+found? (y/n)"))) {
 				errors_corrected++;
 				f = updated;
 				if(add_inode_to_lf(ip)) {
@@ -112,37 +114,37 @@
 					lf_addition = 1;
 				}
 			} else
-				log_err("Unlinked inode left unlinked\n");
+				log_err( _("Unlinked inode left unlinked\n"));
 			fsck_inode_put(ip, f);
 		} /* if(ii->counted_links == 0) */
 		else if(ii->link_count != ii->counted_links) {
-			log_err("Link count inconsistent for inode %" PRIu64
-					" (0x%" PRIx64 ") has %u but fsck found %u.\n", ii->inode, 
+			log_err( _("Link count inconsistent for inode %" PRIu64
+					" (0x%" PRIx64 ") has %u but fsck found %u.\n"), ii->inode, 
 					ii->inode, ii->link_count, ii->counted_links);
 			/* Read in the inode, adjust the link count,
 			 * and write it back out */
 			errors_found++;
-			if(query(&opts, "Update link count for inode %"
-				 PRIu64 " (0x%" PRIx64 ") ? (y/n) ", ii->inode, ii->inode)) {
+			if(query(&opts, _("Update link count for inode %"
+				 PRIu64 " (0x%" PRIx64 ") ? (y/n) "), ii->inode, ii->inode)) {
 				errors_corrected++;
 				ip = fsck_load_inode(sbp, ii->inode); /* bread, inode_get */
 				fix_inode_count(sbp, ii, ip);
 				fsck_inode_put(ip, updated); /* out, brelse, free */
-				log_warn("Link count updated for inode %"
-						 PRIu64 " (0x%" PRIx64 ") \n", ii->inode, ii->inode);
+				log_warn( _("Link count updated for inode %"
+						 PRIu64 " (0x%" PRIx64 ") \n"), ii->inode, ii->inode);
 			} else {
-				log_err("Link count for inode %" PRIu64 " (0x%" PRIx64
-						") still incorrect\n", ii->inode, ii->inode);
+				log_err( _("Link count for inode %" PRIu64 " (0x%" PRIx64
+						") still incorrect\n"), ii->inode, ii->inode);
 			}
 		}
-		log_debug("block %" PRIu64 " (0x%" PRIx64 ") has link count %d\n",
+		log_debug( _("block %" PRIu64 " (0x%" PRIx64 ") has link count %d\n"),
 				  ii->inode, ii->inode, ii->link_count);
 	} /* osi_list_foreach(tmp, list) */
 
 	if (lf_addition) {
 		if(!(ii = inode_hash_search(inode_hash,
 									lf_dip->i_di.di_num.no_addr))) {
-			log_crit("Unable to find lost+found inode in inode_hash!!\n");
+			log_crit( _("Unable to find lost+found inode in inode_hash!!\n"));
 			return -1;
 		} else {
 			fix_inode_count(sbp, ii, lf_dip);
@@ -166,9 +168,9 @@
 	uint32_t i;
 	osi_list_t *list;
 	if(lf_dip)
-		log_debug("At beginning of pass4, lost+found entries is %u\n",
+		log_debug( _("At beginning of pass4, lost+found entries is %u\n"),
 				  lf_dip->i_di.di_entries);
-	log_info("Checking inode reference counts.\n");
+	log_info( _("Checking inode reference counts.\n"));
 	for (i = 0; i < FSCK_HASH_SIZE; i++) {
 		if (skip_this_pass || fsck_abort) /* if asked to skip the rest */
 			return FSCK_OK;
@@ -180,7 +182,7 @@
 	}
 
 	if(lf_dip)
-		log_debug("At end of pass4, lost+found entries is %u\n",
+		log_debug( _("At end of pass4, lost+found entries is %u\n"),
 				  lf_dip->i_di.di_entries);
 	return FSCK_OK;
 }
diff -Naurd cluster-3.0.0.rc2/gfs2/fsck/pass5.c cluster-3.0.0.rc3/gfs2/fsck/pass5.c
--- cluster-3.0.0.rc2/gfs2/fsck/pass5.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/fsck/pass5.c	2009-06-11 11:02:55.000000000 +0200
@@ -2,13 +2,15 @@
 #include <string.h>
 #include <inttypes.h>
 #include <stdlib.h>
+#include <libintl.h>
+#define _(String) gettext(String)
 
 #include "libgfs2.h"
 #include "fsck.h"
 #include "fs_bits.h"
 #include "util.h"
 
-int convert_mark(struct gfs2_block_query *q, uint32_t *count)
+static int convert_mark(struct gfs2_block_query *q, uint32_t *count)
 {
 	if (q->eattr_block) {
 		count[2]++;
@@ -45,13 +47,13 @@
 		return GFS2_BLKST_USED;
 
 	default:
-		log_err("Invalid state %d found\n", q->block_type);
+		log_err( _("Invalid state %d found\n"), q->block_type);
 		return -1;
 	}
 	return -1;
 }
 
-int check_block_status(struct gfs2_sbd *sbp, char *buffer, unsigned int buflen,
+static int check_block_status(struct gfs2_sbd *sbp, char *buffer, unsigned int buflen,
 					   uint64_t *rg_block, uint64_t rg_data, uint32_t *count)
 {
 	unsigned char *byte, *end;
@@ -82,31 +84,31 @@
 		   So we ignore it. */
 		if (rg_status == GFS2_BLKST_UNLINKED &&
 		    block_status == GFS2_BLKST_FREE) {
-			log_warn("Unlinked block found at block %"
-				 PRIu64" (0x%" PRIx64 "), left unchanged.\n",
+			log_warn( _("Unlinked block found at block %"
+				 PRIu64" (0x%" PRIx64 "), left unchanged.\n"),
 				 block, block);
 		} else if (rg_status != block_status) {
 			const char *blockstatus[] = {"Free", "Data", "Unlinked", "inode"};
 
-			log_err("Ondisk and fsck bitmaps differ at"
-					" block %"PRIu64" (0x%" PRIx64 ") \n", block, block);
-			log_err("Ondisk status is %u (%s) but FSCK thinks it should be ",
+			log_err( _("Ondisk and fsck bitmaps differ at"
+					" block %"PRIu64" (0x%" PRIx64 ") \n"), block, block);
+			log_err( _("Ondisk status is %u (%s) but FSCK thinks it should be "),
 					rg_status, blockstatus[rg_status]);
 			log_err("%u (%s)\n", block_status, blockstatus[block_status]);
-			log_err("Metadata type is %u (%s)\n", q.block_type,
+			log_err( _("Metadata type is %u (%s)\n"), q.block_type,
 					block_type_string(&q));
 
 			errors_found++;
-			if(query(&opts, "Fix bitmap for block %"
-					 PRIu64" (0x%" PRIx64 ") ? (y/n) ", block, block)) {
+			if(query(&opts, _("Fix bitmap for block %"
+					 PRIu64" (0x%" PRIx64 ") ? (y/n) "), block, block)) {
 				errors_corrected++;
 				if(gfs2_set_bitmap(sbp, block, block_status))
-					log_err("Failed.\n");
+					log_err( _("Failed.\n"));
 				else
-					log_err("Succeeded.\n");
+					log_err( _("Succeeded.\n"));
 			} else
-				log_err("Bitmap at block %"PRIu64" (0x%" PRIx64
-						") left inconsistent\n", block, block);
+				log_err( _("Bitmap at block %"PRIu64" (0x%" PRIx64
+						") left inconsistent\n"), block, block);
 		}
 		(*rg_block)++;
 		bit += GFS2_BIT_SIZE;
@@ -119,7 +121,7 @@
 	return 0;
 }
 
-enum update_flags update_rgrp(struct gfs2_sbd *sbp, struct rgrp_list *rgp,
+static enum update_flags update_rgrp(struct gfs2_sbd *sbp, struct rgrp_list *rgp,
 							  uint32_t *count)
 {
 	uint32_t i;
@@ -139,8 +141,8 @@
 
 	/* actually adjust counters and write out to disk */
 	if(rgp->rg.rg_free != count[0]) {
-		log_err("RG #%llu (0x%llx) free count inconsistent: "
-			"is %u should be %u\n",
+		log_err( _("RG #%llu (0x%llx) free count inconsistent: "
+			"is %u should be %u\n"),
 			(unsigned long long)rgp->ri.ri_addr,
 			(unsigned long long)rgp->ri.ri_addr,
 			rgp->rg.rg_free, count[0]);
@@ -148,7 +150,7 @@
 		update = 1;
 	}
 	if(rgp->rg.rg_dinodes != count[1]) {
-		log_err("Inode count inconsistent: is %u should be %u\n",
+		log_err( _("Inode count inconsistent: is %u should be %u\n"),
 				rgp->rg.rg_dinodes, count[1]);
 		rgp->rg.rg_dinodes = count[1];
 		update = 1;
@@ -157,19 +159,19 @@
 		/* FIXME not sure how to handle this case ATM - it
 		 * means that the total number of blocks we've counted
 		 * exceeds the blocks in the rg */
-		log_err("Internal fsck error - AAHHH!\n");
+		log_err( _("Internal fsck error - AAHHH!\n"));
 		exit(FSCK_ERROR);
 	}
 	if(update) {
 		errors_found++;
-		if(query(&opts, "Update resource group counts? (y/n) ")) {
+		if(query(&opts, _("Update resource group counts? (y/n) "))) {
 			errors_corrected++;
-			log_warn("Resource group counts updated\n");
+			log_warn( _("Resource group counts updated\n"));
 			/* write out the rgrp */
 			gfs2_rgrp_out(&rgp->rg, rgp->bh[0]->b_data);
 			return updated;
 		} else
-			log_err("Resource group counts left inconsistent\n");
+			log_err( _("Resource group counts left inconsistent\n"));
 	}
 	return not_updated;
 }
@@ -193,7 +195,7 @@
 
 		if (skip_this_pass || fsck_abort) /* if asked to skip the rest */
 			return FSCK_OK;
-		log_info("Verifying Resource Group #%" PRIu64 "\n", rg_count);
+		log_info( _("Verifying Resource Group #%" PRIu64 "\n"), rg_count);
 		memset(count, 0, sizeof(count));
 		rgp = osi_list_entry(tmp, struct rgrp_list, list);
 
diff -Naurd cluster-3.0.0.rc2/gfs2/fsck/rgrepair.c cluster-3.0.0.rc3/gfs2/fsck/rgrepair.c
--- cluster-3.0.0.rc2/gfs2/fsck/rgrepair.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/fsck/rgrepair.c	2009-06-11 11:02:55.000000000 +0200
@@ -5,6 +5,8 @@
 #include <stdlib.h>
 #include <string.h>
 #include <errno.h>
+#include <libintl.h>
+#define _(String) gettext(String)
 
 #include "libgfs2.h"
 #include "osi_list.h"
@@ -34,7 +36,7 @@
  * for a real RG block.  These are "fake" RGs that need to be ignored for
  * the purposes of finding where things are.
  */
-void find_journaled_rgs(struct gfs2_sbd *sdp)
+static void find_journaled_rgs(struct gfs2_sbd *sdp)
 {
 	int j, new = 0;
 	unsigned int jblocks;
@@ -45,7 +47,7 @@
 
 	osi_list_init(&false_rgrps.list);
 	for (j = 0; j < sdp->md.journals; j++) {
-		log_debug("Checking for RGs in journal%d.\n", j);
+		log_debug( _("Checking for RGs in journal%d.\n"), j);
 		ip = sdp->md.journal[j];
 		jblocks = ip->i_di.di_size / sdp->sd_sb.sb_bsize;
 		for (b = 0; b < jblocks; b++) {
@@ -55,8 +57,8 @@
 				break;
 			bh = bread(&sdp->buf_list, dblock);
 			if (!gfs2_check_meta(bh, GFS2_METATYPE_RG)) {
-				log_debug("False RG found at block "
-					  "0x%" PRIx64 "\n", dblock);
+				log_debug( _("False RG found at block "
+					  "0x%" PRIx64 "\n"), dblock);
 				gfs2_special_set(&false_rgrps, dblock);
 			}
 			brelse(bh, not_updated);
@@ -64,7 +66,7 @@
 	}
 }
 
-int is_false_rg(uint64_t block)
+static int is_false_rg(uint64_t block)
 {
 	if (blockfind(&false_rgrps, block))
 		return 1;
@@ -96,7 +98,7 @@
  * same RG size determined by the original mkfs, so recovery is easier.
  *
  */
-int gfs2_rindex_rebuild(struct gfs2_sbd *sdp, osi_list_t *ret_list,
+static int gfs2_rindex_rebuild(struct gfs2_sbd *sdp, osi_list_t *ret_list,
 			 int *num_rgs)
 {
 	struct gfs2_buffer_head *bh;
@@ -131,7 +133,7 @@
 		if (((blk == sdp->sb_addr + 1) ||
 		    (!gfs2_check_meta(bh, GFS2_METATYPE_RG))) &&
 		    !is_false_rg(blk)) {
-			log_debug("RG found at block 0x%" PRIx64 "\n", blk);
+			log_debug( _("RG found at block 0x%" PRIx64 "\n"), blk);
 			if (blk > sdp->sb_addr + 1) {
 				uint64_t rgdist;
 				
@@ -152,7 +154,7 @@
 					first_rg_dist = rgdist;
 				if (rgdist < shortest_dist_btwn_rgs) {
 					shortest_dist_btwn_rgs = rgdist;
-					log_debug("(shortest so far)\n");
+					log_debug( _("(shortest so far)\n"));
 				}
 				else
 					log_debug("\n");
@@ -171,8 +173,8 @@
 	/* first_rg_dist would measure from #1 to #3, which would be bad. */
 	/* We need to take remedial measures to fix it (from the index).  */
 	/* -------------------------------------------------------------- */
-	log_debug("First RG distance: 0x%" PRIx64 "\n", first_rg_dist);
-	log_debug("Distance between RGs: 0x%" PRIx64 "\n",
+	log_debug( _("First RG distance: 0x%" PRIx64 "\n"), first_rg_dist);
+	log_debug( _("Distance between RGs: 0x%" PRIx64 "\n"),
 		  shortest_dist_btwn_rgs);
 	if (first_rg_dist >= shortest_dist_btwn_rgs +
 	    (shortest_dist_btwn_rgs / 4)) {
@@ -182,18 +184,18 @@
 			   sizeof(struct gfs2_rindex));
 		gfs2_rindex_in(&tmpndx, (char *)&buf);
 		if (tmpndx.ri_addr > sdp->sb_addr + 1) { /* sanity check */
-			log_warn("RG 2 is damaged: getting dist from index: ");
+			log_warn( _("RG 2 is damaged: getting dist from index: "));
 			first_rg_dist = tmpndx.ri_addr - (sdp->sb_addr + 1);
 			log_warn("0x%" PRIx64 "\n", first_rg_dist);
 		}
 		else {
-			log_warn("RG index 2 is damaged: extrapolating dist: ");
+			log_warn( _("RG index 2 is damaged: extrapolating dist: "));
 			first_rg_dist = sdp->device.length -
 				(sdp->rgrps - 1) *
 				(sdp->device.length / sdp->rgrps);
 			log_warn("0x%" PRIx64 "\n", first_rg_dist);
 		}
-		log_debug("Adjusted first RG distance: 0x%" PRIx64 "\n",
+		log_debug( _("Adjusted first RG distance: 0x%" PRIx64 "\n"),
 			  first_rg_dist);
 	} /* if first RG distance is within tolerance */
 	/* -------------------------------------------------------------- */
@@ -204,14 +206,14 @@
 	block_bump = first_rg_dist;
 	for (blk = sdp->sb_addr + 1; blk <= sdp->device.length;
 	     blk += block_bump) {
-		log_debug("Block 0x%" PRIx64 "\n", blk);
+		log_debug( _("Block 0x%" PRIx64 "\n"), blk);
 		bh = bread(&sdp->nvbuf_list, blk);
 		rg_was_fnd = (!gfs2_check_meta(bh, GFS2_METATYPE_RG));
 		brelse(bh, not_updated);
 		/* Allocate a new RG and index. */
 		calc_rgd = malloc(sizeof(struct rgrp_list));
 		if (!calc_rgd) {
-			log_crit("Can't allocate memory for rg repair.\n");
+			log_crit( _("Can't allocate memory for rg repair.\n"));
 			return -1;
 		}
 		memset(calc_rgd, 0, sizeof(struct rgrp_list));
@@ -224,11 +226,11 @@
 			/* ------------------------------------------------- */
 			corrupt_rgs++;
 			if (corrupt_rgs < 5)
-				log_debug("Missing or damaged RG at block %" 
-					  PRIu64 " (0x%" PRIx64 ")\n",
+				log_debug( _("Missing or damaged RG at block %" 
+					  PRIu64 " (0x%" PRIx64 ")\n"),
 					  blk, blk);
 			else {
-				log_crit("Error: too many bad RGs.\n");
+				log_crit( _("Error: too many bad RGs.\n"));
 				return -1;
 			}
 		}
@@ -250,11 +252,11 @@
 		} /* for subsequent bitmaps */
 		
 		gfs2_compute_bitstructs(sdp, calc_rgd);
-		log_debug("Memory allocated for rg at 0x%llx, bh: %p\n",
+		log_debug( _("Memory allocated for rg at 0x%llx, bh: %p\n"),
 			  (unsigned long long)calc_rgd->ri.ri_addr,
 			  calc_rgd->bh);
 		if (!calc_rgd->bh) {
-			log_crit("Can't allocate memory for bitmap repair.\n");
+			log_crit( _("Can't allocate memory for bitmap repair.\n"));
 			return -1;
 		}
 		calc_rgd->ri.ri_data0 = calc_rgd->ri.ri_addr +
@@ -271,11 +273,11 @@
 				GFS2_NBBY;
 			prev_rgd->ri.ri_bitbytes = prev_rgd->ri.ri_data /
 				GFS2_NBBY;
-			log_debug("Prev ri_data set to: %" PRIx32 ".\n",
+			log_debug( _("Prev ri_data set to: %" PRIx32 ".\n"),
 				  prev_rgd->ri.ri_data);
 		}
 		number_of_rgs++;
-		log_warn("%c RG %d at block 0x%" PRIX64 " %s",
+		log_warn( _("%c RG %d at block 0x%" PRIX64 " %s"),
 			 (rg_was_fnd ? ' ' : '*'), number_of_rgs, blk,
 			 (rg_was_fnd ? "intact" : "*** DAMAGED ***"));
 		prev_rgd = calc_rgd;
@@ -286,7 +288,7 @@
 		else
 			block_bump = shortest_dist_btwn_rgs;
 		if (block_bump != 1)
-			log_warn(" [length 0x%" PRIx64 "]\n", block_bump);
+			log_warn( _(" [length 0x%" PRIx64 "]\n"), block_bump);
 	} /* for each rg block */
 	/* ----------------------------------------------------------------- */
 	/* If we got to the end of the fs, we still need to fix the          */
@@ -302,14 +304,14 @@
 		prev_rgd->ri.ri_data = rgblocks;
 		prev_rgd->ri.ri_data -= prev_rgd->ri.ri_data % GFS2_NBBY;
 		prev_rgd->ri.ri_bitbytes = prev_rgd->ri.ri_data / GFS2_NBBY;
-		log_debug("Prev ri_data set to: %" PRIx32 ".\n",
+		log_debug( _("Prev ri_data set to: %" PRIx32 ".\n"),
 			  prev_rgd->ri.ri_data);
 		prev_rgd = NULL; /* make sure we don't use it later */
 	}
         /* ---------------------------------------------- */
         /* Now dump out the information (if verbose mode) */      
         /* ---------------------------------------------- */
-        log_debug("RG index rebuilt as follows:\n");
+        log_debug( _("RG index rebuilt as follows:\n"));
         for (tmp = ret_list, rgi = 0; tmp != ret_list;
 	     tmp = tmp->next, rgi++) {
                 calc_rgd = osi_list_entry(tmp, struct rgrp_list, list);
@@ -337,13 +339,13 @@
  * Sets:    sdp->rglist to a linked list of fsck_rgrp structs representing
  *          what we think the rindex should really look like.
  */
-int gfs2_rindex_calculate(struct gfs2_sbd *sdp, osi_list_t *ret_list,
+static int gfs2_rindex_calculate(struct gfs2_sbd *sdp, osi_list_t *ret_list,
 			   int *num_rgs)
 {
 	osi_list_init(ret_list);
 	sdp->rgsize = GFS2_DEFAULT_RGSIZE; /* compute_rgrp_layout adjusts */
 	if (device_geometry(sdp)) {
-		fprintf(stderr, "Geometry error\n");
+		fprintf(stderr, _("Geometry error\n"));
 		exit(-1);
 	}
 	if (fix_device_geometry(sdp)) {
@@ -356,7 +358,7 @@
 	compute_rgrp_layout(sdp, FALSE);
 	build_rgrps(sdp, FALSE); /* FALSE = calc but don't write to disk. */
 	*num_rgs = 0;
-	log_debug("fs_total_size = 0x%" PRIX64 " blocks.\n",
+	log_debug( _("fs_total_size = 0x%" PRIX64 " blocks.\n"),
 		  sdp->device.length);
 	/* ----------------------------------------------------------------- */
 	/* Calculate how many RGs there are supposed to be based on the      */
@@ -366,7 +368,7 @@
 	/* the index.                                                        */
 	/* ----------------------------------------------------------------- */
 	*num_rgs = sdp->md.riinode->i_di.di_size / sizeof(struct gfs2_rindex);
-	log_warn("L2: number of rgs in the index = %d.\n", *num_rgs);
+	log_warn( _("L2: number of rgs in the index = %d.\n"), *num_rgs);
 	return 0;
 }
 
@@ -374,20 +376,20 @@
  * rewrite_rg_block - rewrite ("fix") a buffer with rg or bitmap data
  * returns: 0 if the rg was repaired, otherwise 1
  */
-int rewrite_rg_block(struct gfs2_sbd *sdp, struct rgrp_list *rg,
+static int rewrite_rg_block(struct gfs2_sbd *sdp, struct rgrp_list *rg,
 		     uint64_t errblock)
 {
 	int x = errblock - rg->ri.ri_addr;
 
-	log_err("Block #%"PRIu64" (0x%" PRIx64") (%d of %d) is neither"
-		" GFS2_METATYPE_RB nor GFS2_METATYPE_RG.\n",
+	log_err( _("Block #%"PRIu64" (0x%" PRIx64") (%d of %d) is neither"
+		" GFS2_METATYPE_RB nor GFS2_METATYPE_RG.\n"),
 		rg->bh[x]->b_blocknr, rg->bh[x]->b_blocknr,
 		(int)x+1, (int)rg->ri.ri_length);
 	errors_found++;
 	if (query(&opts, "Fix the RG? (y/n)")) {
 
 		errors_corrected++;
-		log_err("Attempting to repair the RG.\n");
+		log_err( _("Attempting to repair the RG.\n"));
 		rg->bh[x] = bread(&sdp->nvbuf_list, rg->ri.ri_addr + x);
 		if (x) {
 			struct gfs2_meta_header mh;
@@ -422,7 +424,7 @@
 {
 	int error, descrepencies;
 	osi_list_t expected_rglist;
-	int calc_rg_count, rgcount_from_index, rg;
+	int calc_rg_count = 0, rgcount_from_index, rg;
 	osi_list_t *exp, *act; /* expected, actual */
 	struct gfs2_rindex buf;
 
@@ -441,7 +443,7 @@
 		error = gfs2_rindex_rebuild(sdp, &expected_rglist,
 					     &calc_rg_count);
 		if (error) {
-			log_crit("Error rebuilding rg list.\n");
+			log_crit( _("Error rebuilding rg list.\n"));
 			gfs2_rgrp_free(&expected_rglist, not_updated);
 			return -1;
 		}
@@ -451,16 +453,16 @@
 	osi_list_init(&sdp->rglist); /* Just to be safe */
 	rindex_read(sdp, 0, &rgcount_from_index);
 	if (sdp->md.riinode->i_di.di_size % sizeof(struct gfs2_rindex)) {
-		log_warn("WARNING: rindex file is corrupt.\n");
+		log_warn( _("WARNING: rindex file is corrupt.\n"));
 		gfs2_rgrp_free(&expected_rglist, not_updated);
 		gfs2_rgrp_free(&sdp->rglist, not_updated);
 		return -1;
 	}
-	log_warn("L%d: number of rgs expected     = %lld.\n", trust_lvl + 1,
+	log_warn( _("L%d: number of rgs expected     = %lld.\n"), trust_lvl + 1,
 		 (unsigned long long)sdp->rgrps);
 	if (calc_rg_count != sdp->rgrps) {
-		log_warn("L%d: They don't match; either (1) the fs was extended, (2) an odd\n", trust_lvl + 1);
-		log_warn("L%d: rg size was used, or (3) we have a corrupt rg index.\n", trust_lvl + 1);
+		log_warn( _("L%d: They don't match; either (1) the fs was extended, (2) an odd\n"), trust_lvl + 1);
+		log_warn( _("L%d: rg size was used, or (3) we have a corrupt rg index.\n"), trust_lvl + 1);
 		gfs2_rgrp_free(&expected_rglist, not_updated);
 		gfs2_rgrp_free(&sdp->rglist, not_updated);
 		return -1;
@@ -489,9 +491,9 @@
 		}
 	}
 	if (trust_lvl < distrust && descrepencies > (trust_lvl * 8)) {
-		log_warn("Level %d didn't work.  Too many descepencies.\n",
+		log_warn( _("Level %d didn't work.  Too many descepencies.\n"),
 			 trust_lvl + 1);
-		log_warn("%d out of %d RGs did not match what was expected.\n",
+		log_warn( _("%d out of %d RGs did not match what was expected.\n"),
 			 descrepencies, rg);
 		gfs2_rgrp_free(&expected_rglist, not_updated);
 		gfs2_rgrp_free(&sdp->rglist, not_updated);
@@ -517,7 +519,7 @@
 		/* If we modified the index, write it back to disk. */
 		if (rindex_modified) {
 			errors_found++;
-			if (query(&opts, "Fix the index? (y/n)")) {
+			if (query(&opts, _("Fix the index? (y/n)"))) {
 				errors_corrected++;
 				gfs2_rindex_out(&expected->ri, (char *)&buf);
 				gfs2_writei(sdp->md.riinode, (char *)&buf,
@@ -540,7 +542,7 @@
 				gfs2_compute_bitstructs(sdp, actual);
 			}
 			else
-				log_err("RG index not fixed.\n");
+				log_err( _("RG index not fixed.\n"));
 			rindex_modified = FALSE;
 			
 		}
diff -Naurd cluster-3.0.0.rc2/gfs2/fsck/util.c cluster-3.0.0.rc3/gfs2/fsck/util.c
--- cluster-3.0.0.rc2/gfs2/fsck/util.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/fsck/util.c	2009-06-11 11:02:55.000000000 +0200
@@ -4,42 +4,13 @@
 #include <unistd.h>
 #include <sys/time.h>
 #include <stdio.h>
+#include <libintl.h>
+#define _(String) gettext(String)
 
 #include "libgfs2.h"
 #include "fs_bits.h"
 #include "util.h"
 
-/**
- * compute_height
- * @sdp:
- * @sz:
- *
- */
-int compute_height(struct gfs2_sbd *sdp, uint64_t sz)
-{
-	unsigned int height;
-	uint64_t space, old_space;
-	unsigned int bsize = sdp->sd_sb.sb_bsize;
-	
-	if (sz <= (bsize - sizeof(struct gfs2_dinode)))
-		return 0;
-	
-	height = 1;
-	space = sdp->sd_diptrs * bsize;
-	
-	while (sz > space) {
-		old_space = space;
-		
-		height++;
-		space *= sdp->sd_inptrs;
-		
-		if (space / sdp->sd_inptrs != old_space ||
-			space % sdp->sd_inptrs != 0)
-			break;
-	}
-	return height;
-}
-
 /* Put out a warm, fuzzy message every second so the user     */
 /* doesn't think we hung.  (This may take a long time).       */
 void warm_fuzzy_stuff(uint64_t block)
@@ -61,7 +32,7 @@
 			seconds = tv.tv_sec;
 			if (last_fs_block) {
 				percent = (block * 100) / last_fs_block;
-				log_notice("\r%" PRIu64 " percent complete.\r", percent);
+				log_notice( _("\r%" PRIu64 " percent complete.\r"), percent);
 			}
 		}
 	}
diff -Naurd cluster-3.0.0.rc2/gfs2/fsck/util.h cluster-3.0.0.rc3/gfs2/fsck/util.h
--- cluster-3.0.0.rc2/gfs2/fsck/util.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/fsck/util.h	2009-06-11 11:02:55.000000000 +0200
@@ -6,7 +6,6 @@
 #define fsck_lseek(fd, off) \
   ((lseek((fd), (off), SEEK_SET) == (off)) ? 0 : -1)
 
-int compute_height(struct gfs2_sbd *sdp, uint64_t sz);
 struct di_info *search_list(osi_list_t *list, uint64_t addr);
 void warm_fuzzy_stuff(uint64_t block);
 const char *block_type_string(struct gfs2_block_query *q);
diff -Naurd cluster-3.0.0.rc2/gfs2/libgfs2/block_list.c cluster-3.0.0.rc3/gfs2/libgfs2/block_list.c
--- cluster-3.0.0.rc2/gfs2/libgfs2/block_list.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/libgfs2/block_list.c	2009-06-11 11:02:55.000000000 +0200
@@ -182,7 +182,7 @@
 	}
 }
 
-void gfs2_dup_free(struct dup_blocks *blist)
+static void gfs2_dup_free(struct dup_blocks *blist)
 {
 	struct dup_blocks *f;
 
@@ -209,7 +209,7 @@
 	return NULL;
 }
 
-struct dup_blocks *dupfind(struct dup_blocks *blist, uint64_t num)
+static struct dup_blocks *dupfind(struct dup_blocks *blist, uint64_t num)
 {
 	osi_list_t *head = &blist->list;
 	osi_list_t *tmp;
@@ -238,7 +238,7 @@
 	return;
 }
 
-void gfs2_dup_set(struct dup_blocks *blocklist, uint64_t block)
+static void gfs2_dup_set(struct dup_blocks *blocklist, uint64_t block)
 {
 	struct dup_blocks *b;
 
diff -Naurd cluster-3.0.0.rc2/gfs2/libgfs2/buf.c cluster-3.0.0.rc3/gfs2/libgfs2/buf.c
--- cluster-3.0.0.rc2/gfs2/libgfs2/buf.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/libgfs2/buf.c	2009-06-11 11:02:55.000000000 +0200
@@ -172,11 +172,11 @@
 	return bh;
 }
 
-void brelse(struct gfs2_buffer_head *bh, enum update_flags updated)
+void brelse(struct gfs2_buffer_head *bh, enum update_flags is_updated)
 {
     /* We can't just say b_changed = updated because we don't want to     */
 	/* set it FALSE if it's TRUE until we write the changed data to disk. */
-	if (updated)
+	if (is_updated)
 		bh->b_changed = TRUE;
 	if (!bh->b_count) {
 		fprintf(stderr, "buffer count underflow for block %" PRIu64
diff -Naurd cluster-3.0.0.rc2/gfs2/libgfs2/fs_geometry.c cluster-3.0.0.rc3/gfs2/libgfs2/fs_geometry.c
--- cluster-3.0.0.rc2/gfs2/libgfs2/fs_geometry.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/libgfs2/fs_geometry.c	2009-06-11 11:02:55.000000000 +0200
@@ -178,7 +178,7 @@
  * If fd > 0, write the data to the given file handle.
  * Otherwise, use gfs2 buffering in buf.c.
  */
-void build_rgrps(struct gfs2_sbd *sdp, int write)
+void build_rgrps(struct gfs2_sbd *sdp, int do_write)
 {
 	osi_list_t *tmp, *head;
 	struct rgrp_list *rl;
@@ -215,7 +215,7 @@
 		rg->rg_flags = rl->rgf_flags;
 		rg->rg_free = rgblocks;
 
-		if (write) {
+		if (do_write) {
 			for (x = 0; x < bitblocks; x++) {
 				bh = bget(&sdp->nvbuf_list, rl->start + x);
 				if (x)
